# FACT Buildings Footprint and Height
ML detected building footprints and height open database. Bing Maps open building footprints. with partial global coverage, only US and Europe included here.

---

[![GitLab License](https://img.shields.io/gitlab/license/fact%2Fdata%2FFACT_bldgs?gitlab_url=https%3A%2F%2Fgit.nilu.no&style=flat&color=orange)](https://www.gnu.org/licenses/old-licenses/gpl-2.0.html)
[![DOI](https://img.shields.io/badge/DOI-10.17605%2FOSF.IO%2FPV4ZW-blue?style=flat)](https://doi.org/10.17605/OSF.IO/PV4ZW)
[![Data License](https://img.shields.io/badge/data-ODbL%20v1.0-green)](https://opendatacommons.org/licenses/odbl/1-0/)

---

## Use
1. Through the command line:
```bash
docker pull registry.git.nilu.no/fact/data/fact_bldgs:latest
docker run -t -i --name fact_bldgs -e MARIADB_DATABASE=FACT_bldgs -e MYSQL_ROOT_PASSWORD=devops -p 3315:3306 -d registry.git.nilu.no/fact/data/fact_bldgs:0.1
```
2. Through a docker-compose file:
```yaml
version: '3.8'

services:
  fact_bldgs:
    image: registry.git.nilu.no/fact/data/fact_bldgs:latest
    container_name: fact_bldgs
    environment:
      MARIADB_DATABASE: FACT_bldgs
      MYSQL_ROOT_PASSWORD: devops
    ports:
      - "3315:3306"
    restart: unless-stopped
```
which could be executed with `docker-compose up fact_bldgs -d`.

The container makes available a MariaDB instance with the full database on airports and traffic **FACT_bldgs**. It is reachable on port 3315 of the localhost and the password is 'devops'.

---
## Specifications
```
Table           |Size (MB)|Rows (#) |
----------------+---------+---------+
footprints      | 91081.03|341191944|
geometry_columns|     0.02|        0|
spatial_ref_sys |     0.02|        0|
```

![tables schema](FACT_bldgs.png "Tables")

Properties in footprints contain a dictionary with height (-1 if missing) and confidence, example:
>{ "height": -1.0, "confidence": -1.0 }

**All spatial objects are converted to EPSG:4326.**

---
## Notes
The code downloads files for European countries and US, transforms them into geojson with right CRS, and then loads them into a DB.

The input data is available from https://github.com/microsoft/GlobalMLBuildingFootprints

---
## Author
Riccardo Boero - ribo@nilu.no

## License
All the code and the resulting docker images in this project are subject to:
- [GNU Generla Public License v2](https://www.gnu.org/licenses/old-licenses/gpl-2.0.html).

The data is licensed under:
- the Open Data Commons Open Database License [(ODbL) v1.0](https://opendatacommons.org/licenses/odbl/1-0/).

## Citation
- Boero, Riccardo. 2024. “FACT Data: Buildings Footprint and Height.” OSF. [doi:10.17605/OSF.IO/CHDJR](https://doi.org/10.17605/OSF.IO/CHDJR). 

Part of the Fine scAle eConomic daTa - FACT project:
- Boero, Riccardo. 2024. “Fine scAle eConomic daTa - FACT.” OSF. [doi:10.17605/OSF.IO/PV4ZW](https://doi.org/10.17605/OSF.IO/PV4ZW). 